% Author: Housam Binous

% National Institute of Applied Sciences and Technology, Tunis, TUNISIA

% Email: binoushousam@yahoo.com

global Xea X Psatexp para

clc

options = optimset('Display','off');

for i=1:11
    T(i)=380.15+i*20;
    ps(i)=fsolve(@(ps) FKTeq(ps,T(i)),0.5,options);
end

Texp=T;

Psatexp=ps;

figure(1)

plot(T,ps,'r')


% running the genetic algorithm 10 times in order to select 
% the best result

for j=1:10
    
binous2;

j

f(j)=0;

for i=1:11
    T(i)=380.15+i*20;
    para=X;
    if (i==1) Psattheo(j,i)=fsolve(@(ps) FKTeq2(ps,T(i)),0.5,options);
    else Psattheo(j,i)=fsolve(@(ps) FKTeq2(ps,T(i)),Psattheo(j,i-1),options); 
    end
    f(j)=f(j)+(Psattheo(j,i)-Psatexp(i))^2;
end

Xea(j,:)=X;

end

% select best result and plot experimental and predicted data
% Xea contains best result for the three parameters 
% of the Frost-Kalkwarf-Thodos Equation

[f,k]=min(f);

Xea(k,:)

figure(2)
plot(Texp,Psatexp,'r*');
hold on
plot(Texp,Psattheo(k,:),'b');
axis tight
xlabel('Temperature in K')
ylabel('Vapor Pressure in bar')
